package com.tbs.utils {
	import flash.display.*;
	import flash.events.*;
	import flash.media.*;
	import flash.net.*;
	import flash.system.ApplicationDomain;
	import flash.system.LoaderContext;
	import flash.utils.ByteArray;
	
	public class TbsLoader {
		
		/**
		 * 以 / 结尾
		 */	
		public static var baseUrl:String = "";
		public static var addFlag:Boolean = false;
		
		public static function loadImage(url:String, completedFun:Function, progressFun:Function=null, baseOnBaseUrl:Boolean = true):void{
			var loader:Loader = new Loader();
			var completedFun:Function = completedFun;
			var progressFun:Function = progressFun;
			loader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS, function (event:ProgressEvent):void{
				if (progressFun != null){
					progressFun((event.bytesLoaded / event.bytesTotal));
				};
			});
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, function (event:Event):void{
				completedFun((loader.content as Bitmap).bitmapData);
			});
			
			var disUrl:String = url;
			if(baseOnBaseUrl){
				disUrl = baseUrl + url;
			}
			if(addFlag){
				disUrl += "?r=" + R;
			}
			loader.load(new URLRequest(disUrl));
		}
		public static function loadSwf(url:String, completedFun:Function, progressFun:Function=null, baseOnBaseUrl:Boolean = true):void{
			var loader:Loader = new Loader();
			var completedFun:Function = completedFun;
			var progressFun:Function = progressFun;
			loader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS, function (event:ProgressEvent):void{
				if (progressFun != null){
					progressFun((event.bytesLoaded / event.bytesTotal));
				};
			});
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, function (event:Event):void{
				completedFun((loader.content as MovieClip));
			});
			
			var disUrl:String = url;
			if(baseOnBaseUrl){
				disUrl = baseUrl + url;
			}
			if(addFlag){
				disUrl += "?r=" + R;
			}
			loader.load(new URLRequest(disUrl));
		}
		public static function loadDefinition(url:String, completedFun:Function, progressFun:Function=null, baseOnBaseUrl:Boolean = true):void{
			var loader:URLLoader = new URLLoader();
			loader.dataFormat = URLLoaderDataFormat.BINARY;
			loader.addEventListener(ProgressEvent.PROGRESS, function (event:ProgressEvent):void{
				if (progressFun != null){
					progressFun((event.bytesLoaded / event.bytesTotal));
				};
			});
			loader.addEventListener(Event.COMPLETE, function (event:Event):void{
				var data:ByteArray = loader.data as ByteArray;
				var ld:Loader = new Loader();
				ld.contentLoaderInfo.addEventListener(Event.COMPLETE, function(e:Event):void{
					completedFun();
				});
				ld.loadBytes(data, new LoaderContext(false, ApplicationDomain.currentDomain));
			});
			
			var disUrl:String = url;
			if(baseOnBaseUrl){
				disUrl = baseUrl + url;
			}
			if(addFlag){
				disUrl += "?r=" + R;
			}
			loader.load(new URLRequest(disUrl));
		}
		public static function loadXml(url:String, completedFun:Function, progressFun:Function=null, baseOnBaseUrl:Boolean = true):void{
			var loader:URLLoader = new URLLoader();
			var completedFun:Function = completedFun;
			var progressFun:Function = progressFun;
			loader.addEventListener(ProgressEvent.PROGRESS, function (event:ProgressEvent):void{
				if (progressFun != null){
					progressFun((event.bytesLoaded / event.bytesTotal));
				};
			});
			loader.addEventListener(Event.COMPLETE, function (event:Event):void{
				completedFun(new XML(loader.data));
			});
			
			var disUrl:String = url;
			if(baseOnBaseUrl){
				disUrl = baseUrl + url;
			}
			if(addFlag){
				disUrl += "?r=" + R;
			}
			loader.load(new URLRequest(disUrl));
		}
		public static function loadTxt(url:String, completedFun:Function, progressFun:Function=null, baseOnBaseUrl:Boolean = true):void{
			var loader:URLLoader = new URLLoader();
			var completedFun:Function = completedFun;
			var progressFun:Function = progressFun;
			loader.addEventListener(ProgressEvent.PROGRESS, function (event:ProgressEvent):void{
				if (progressFun != null){
					progressFun((event.bytesLoaded / event.bytesTotal));
				};
			});
			loader.addEventListener(Event.COMPLETE, function (event:Event):void{
				if (completedFun != null){
					completedFun(String(loader.data));
				};
			});
			
			var disUrl:String = url;
			if(baseOnBaseUrl){
				disUrl = baseUrl + url;
			}
			if(addFlag){
				disUrl += "?r=" + R;
			}
			loader.load(new URLRequest(disUrl));
		}
		public static function loadSound(url:String, completedFun:Function, progressFun:Function=null, baseOnBaseUrl:Boolean = true):void{
			var sound:Sound = new Sound();
			var completedFun:Function = completedFun;
			var progressFun:Function = progressFun;
			sound.addEventListener(ProgressEvent.PROGRESS, function (event:ProgressEvent):void{
				if (progressFun != null){
					progressFun((event.bytesLoaded / event.bytesTotal));
				};
			});
			sound.addEventListener(Event.COMPLETE, function (event:Event):void{
				completedFun(sound);
			});
			
			var disUrl:String = url;
			if(baseOnBaseUrl){
				disUrl = baseUrl + url;
			}
			if(addFlag){
				disUrl += "?r=" + R;
			}
			sound.load(new URLRequest(disUrl));
		}
		
		public static var myR:String;
		public static function set R(value:String):void{
			myR = value;
		}
		public static function get R():String{
			if(myR == null || myR == ""){
				return String(Math.random());
			}else{
				return myR;
			}
			
		}
	}
}